#!/usr/bin/perl -w

##
#This script adds a command "/tv-now CHANNEL" to
#print the actually running programm on CHANNEL.
#Or you type /tv TIME CHANNEL to see what runs
#on CHANNEL at TIME. type /tv help for more
#informations... - Have fun!
#There are 38 german TV channels supported.
#released under the GNU General Public License
#tv-now.pl - Xchat! - script by David Spreen 2000.
#david@spreen.de
##

use strict;

IRC::print "Loading TV-NOW script 1.0\n";
IRC::print "Type \"/tv-now help\" for help\n";
IRC::add_command_handler("tv-now", "now");
IRC::add_command_handler("tv", "tv");
IRC::register("TV-NOW", 1.0, "", "");

sub now {
	my $elmnt = "@_";
	if ($elmnt ne undef && $elmnt ne "help") {
		open(GTV,"wget -t5 -nv -O- http://yasd.dhs.org/tv2/tv_now.php3 |")||	# get the html-source of the gtv-tv-programm
				die "Cannot get TV-Programm:$!\n"; 
		my @html = <GTV>;
		my $html = join(" ", @html);
        	while ($html =~ m@<tr><td>(\d\d:\d\d)</td><td>(\d\d:\d\d)</td>	# search in the html-source for
			<td>([^<]*)</td>					# the informations of time, channel
			<td><a.*?>([^<]*)</a></td>				# and film.
			<td.*?><td>.*?<a.*?>.*?</a></td></tr>@gix) {
			(my $time, my $time2, my $sender, my $sendung) = ($1, $2, $3, $4);	# $1 is the beginning time, $2 end time
	    											# $3 the channel-name and $4 the film.
			if ($sender eq $elmnt|| $elmnt eq lc $sender|| $elmnt eq "all") {
	    			IRC::print("\0035|$time - $time2 on $sender|\n$sendung\003\n");
			}
		}
		close(GTV);
	} else {
		help();
	}    
	return 1;	# You have to return 1 in other case xchat returns /tv-now: No such command...
}

sub tv {
	(my $time, my @elmnt) = split(" ","@_");
	my $elmnt = "@elmnt";
	if ($elmnt ne undef && $elmnt ne "help") {
		open(GTV,"wget -t5 -nv -O- \"http://yasd.dhs.org/tv2/tv_now.php3?time=$time\" |")||	# get the source
				die "Cannot get TV-Programm:$!\n"; 
		my @html = <GTV>;
		my $html = join(" ", @html);
        	while ($html =~ m@<tr><td>(\d\d:\d\d)</td><td>(\d\d:\d\d)</td>	# search in the html-source for
			<td>([^<]*)</td>					# the informations of time, channel
			<td><a.*?>([^<]*)</a></td>				# and film.
			<td.*?><td>.*?<a.*?>.*?</a></td></tr>@gix) {
			(my $time, my $time2, my $sender, my $sendung) = ($1, $2, $3, $4);	# $1 is the beginning time, $2 end time
	    											# $3 the channel-name and $4 the film.
			if ($sender eq $elmnt|| $elmnt eq lc $sender|| $elmnt eq "all") {
	    			IRC::print("\0035|$time - $time2 on $sender|\n$sendung\003\n");
			}
		}
		close(GTV);
	} else {
		help();
	}    
	return 1;	# You have to return 1 in other case xchat returns /tv-now: No such command...
}




sub help {
	IRC::print "\n\0034type /tv TIME CHANNEL to see what's on CHANNEL at TIME\003\n";
	IRC::print "\0034type /tv TIME all to see the programm of all channels at TIME\003\n";
	
	IRC::print "\n\0034type /tv-now TV-CHANNEL to see what's on TV-CHANNEL now!\003\n";
	IRC::print "\0034or type /tv-now all to see the programm of all channels now\003\n";
	
	IRC::print "\n\0034examples:\003\n";
	IRC::print "\0034/tv 20:15 pro 7\003\n";
	IRC::print "\0034/tv 23:23 all\003\n";
	IRC::print "\0034/tv-now ard\003\n";
	IRC::print "\0034...\003\n\n";
		
	IRC::print "\0034Available TV-Channels:\003\n";
	IRC::print "\0034BAYERN, N-TV, CARTOON, E-NEWS, SRTL, NBC, MTV, VH1, VIVA II, VIVA,\003\n";
	IRC::print "\0034E-SPORT, 3SAT, ARTE, ORF1, ORF2, KABEL 1, PRO 7, RTL 2, RTL, TM3,\003\n";
	IRC::print "\0034SW III, WEST, PREMIERE, B1/SFB, NORD, DSF, ARD, ZDF, SAT.1, MDR,\003\n";
	IRC::print "\0034PHOENIX, TRT, KINDER KANAL, TNT, TV5, HESSEN, ORB, VOX\003\n";
	IRC::print "\0034Have Fun.\003\n";
}
	
